"use strict";var _prototypeProperties=function(e,t,n){t&&Object.defineProperties(e,t),n&&Object.defineProperties(e.prototype,n)},_get=function e(t,n,r){var i=Object.getOwnPropertyDescriptor(t,n);if(void 0===i){var o=Object.getPrototypeOf(t);return null===o?void 0:e(o,n,r)}if("value"in i&&i.writable)return i.value;var l=i.get;if(void 0!==l)return l.call(r)},_inherits=function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(e.__proto__=t)},_classCallCheck=function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")},_=require("lodash"),path=require("path"),fs=require("fs"),Datastore=require("nedb"),DatabaseClient=require("./client"),urlToPath=function(e){return e.indexOf("nedb://")>-1?e.slice(7,e.length):e},getCollectionPath=function(e,t){return"memory"===e?e:path.join(e,t)+".db"},createCollection=function(e,t){if("memory"===t)return new Datastore({inMemoryOnly:!0});var n=getCollectionPath(t,e);return new Datastore({filename:n,autoload:!0})},getCollection=function(e,t,n){if(!(e in t)){var r=createCollection(e,n);return t[e]=r,r}return t[e]},NeDbClient=function(e){function t(e,n){_classCallCheck(this,t),_get(Object.getPrototypeOf(t.prototype),"constructor",this).call(this,e),this._path=urlToPath(e),this._collections=n||{}}return _inherits(t,e),_prototypeProperties(t,{connect:{value:function(e,n){var r=urlToPath(e);return new Promise(function(e,n){e(new t(r,{}))})},writable:!0,configurable:!0}},{save:{value:function(e,t,n){var r=this;return new Promise(function(i,o){var l=getCollection(e,r._collections,r._path);null===t?l.insert(n,function(e,t){return e?o(e):i(t._id)}):l.update({_id:t},{$set:n},{upsert:!0},function(e,t){return e?o(e):i(t)})})},writable:!0,configurable:!0},delete:{value:function(e,t){var n=this;return new Promise(function(r,i){null===t&&r(0),getCollection(e,n._collections,n._path).remove({_id:t},function(e,t){return e?i(e):r(t)})})},writable:!0,configurable:!0},deleteOne:{value:function(e,t){var n=this;return new Promise(function(r,i){getCollection(e,n._collections,n._path).remove(t,function(e,t){return e?i(e):r(t)})})},writable:!0,configurable:!0},deleteMany:{value:function(e,t){var n=this;return new Promise(function(r,i){getCollection(e,n._collections,n._path).remove(t,{multi:!0},function(e,t){return e?i(e):r(t)})})},writable:!0,configurable:!0},findOne:{value:function(e,t){var n=this;return new Promise(function(r,i){getCollection(e,n._collections,n._path).findOne(t,function(e,t){return e?i(e):r(t)})})},writable:!0,configurable:!0},findOneAndUpdate:{value:function(e,t,n,r){var i=this;return r||(r={}),r.multi=!1,new Promise(function(o,l){var u=getCollection(e,i._collections,i._path);i.findOne(e,t).then(function(e){return e?u.update(t,{$set:n},function(t,n){if(t)return l(t);u.findOne({_id:e._id},function(e,t){if(e)return l(e);o(t)})}):r.upsert?u.insert(n,function(e,t){return e?l(e):o(t)}):o(null)})})},writable:!0,configurable:!0},findOneAndDelete:{value:function(e,t,n){var r=this;return n||(n={}),n.multi=!1,new Promise(function(i,o){getCollection(e,r._collections,r._path).remove(t,n,function(e,t){return e?o(e):i(t)})})},writable:!0,configurable:!0},find:{value:function(e,t,n){var r=this;return new Promise(function(i,o){var l=getCollection(e,r._collections,r._path),u=l.find(t);n.sort&&(_.isArray(n.sort)||_.isString(n.sort))&&function(){var e={};_.isArray(n.sort)||(n.sort=[n.sort]),n.sort.forEach(function(t){if(_.isString(t)){var n=1;"-"===t[0]&&(n=-1,t=t.substring(1)),e[t]=n}}),u=u.sort(e)}(),"number"==typeof n.skip&&(u=u.skip(n.skip)),"number"==typeof n.limit&&(u=u.limit(n.limit)),u.exec(function(e,t){return e?o(e):i(t)})})},writable:!0,configurable:!0},count:{value:function(e,t){var n=this;return new Promise(function(r,i){getCollection(e,n._collections,n._path).count(t,function(e,t){return e?i(e):r(t)})})},writable:!0,configurable:!0},createIndex:{value:function(e,t,n){n=n||{},n.unique=n.unique||!1,n.sparse=n.sparse||!1,getCollection(e,this._collections,this._path).ensureIndex({fieldName:t,unique:n.unique,sparse:n.sparse})},writable:!0,configurable:!0},close:{value:function(){},writable:!0,configurable:!0},clearCollection:{value:function(e){return this.deleteMany(e,{})},writable:!0,configurable:!0},dropDatabase:{value:function(){var e=this,t=[];return _.keys(this._collections).forEach(function(n){var r=new Promise(function(t,r){var i=getCollectionPath(e._path,n);"memory"===i?(delete e._collections[n],t()):fs.stat(i,function(o,l){null===o?fs.unlink(i,function(i){i&&r(i),delete e._collections[n],t()}):t()})});t.push(r)}),Promise.all(t)},writable:!0,configurable:!0},toCanonicalId:{value:function(e){return e},writable:!0,configurable:!0},isNativeId:{value:function(e){return null!==String(e).match(/^[a-zA-Z0-9]{16}$/)},writable:!0,configurable:!0},nativeIdType:{value:function(){return String},writable:!0,configurable:!0},driver:{value:function(){return this._collections},writable:!0,configurable:!0}}),t}(DatabaseClient);module.exports=NeDbClient;