"use strict";const fs=require("fs"),Mustache=require("mustache"),path=require("path"),cookie=require("cookie"),sessions=require("client-sessions"),decode=require("urldecode"),recursive=require("recursive-readdir"),utils=require("./utils"),BUCKET="turbo360-vertex",SESSION_COOKIE_NAME="vertexSession";let shouldClearSession=!1;const proxyVertexSession=function(e,n){return new Proxy(e,{set:function(t,r,s){t==e&&(n.vertexSessionChanged=!0,t[r]=s)}})},readFile=function(e){return new Promise(function(n,t){fs.readFile(e,"utf8",function(r,s){r?t(new Error("File Not Found: "+e)):n(s)})})},writeFile=function(e,n){return new Promise(function(t,r){fs.writeFile(e,n,function(e){e?r(e):t(n)})})},readRecursiveDirectories=function(e){return new Promise(function(n,t){var r=[];fs.existsSync(e)?recursive(e,function(e,s){e?t(e):(s.forEach(function(e){var n={};n.path=e;var t=e.split("/"),s=t[t.length-1];n.name=s.split(".")[0],r.push(n)}),n(r))}):n(r)})},renderMustache=function(e){return new Promise(function(n,t){var r=e.template;if(null!=r){var s=e.data;if(null!=s){var o=e.partials||{};try{var i=s||{};n(Mustache.render(r,i,o))}catch(e){t(e)}}else t(new Error("Missing data"))}else t(new Error("Missing template"))})},getCookieName=function(e){let n="vertexSession";return null!=e&&null!=e.session&&(n=e.session.cookieName||"vertexSession"),n},setVertexSession=function(e,n,t){let r=getCookieName(t);if(1==shouldClearSession)return n["Set-Cookie"]=r+"=deleted; path=/; expires=Thu, 01 Jan 1970 00:00:00 GMT",shouldClearSession=!1,n;if(0==e.vertexSessionChanged)return n;var s=e[r]||{};if(delete s.reset,0==Object.keys(s).length)return n;var o=JSON.stringify(s),i=sessions.util.encode({cookieName:r,secret:"abc"},o,null,null);return n["Set-Cookie"]=r+"="+i+"; path=/;",n},checkPageConfig=function(e,n){const t=__dirname.replace("node_modules/vertex360/dist/vertex","");return new Promise(function(r,s){const o=t+"/pages/"+e+".json";if(0==fs.existsSync(o))return void r(null);const i="/tmp/"+e+".txt";if(fs.existsSync(i)){const e=fs.readFileSync(i,"utf8");try{const n=JSON.parse(e);return void r(n)}catch(e){return void r(null)}return}const a="https://s3.amazonaws.com/"+BUCKET+"/pages/"+n+"/"+e+".txt";var c=null;utils.fetchTextFile(a).then(e=>(c=JSON.parse(e),writeFile(i,e))).then(e=>{r(c)}).catch(n=>{if(null==n.message||"Forbidden"!=n.message)s(n);else{s(new Error(e+" config file ("+(e+".json")+") not found on staging environment. To fix: $ turbo page "+e+". REFERENCE - https://docs.turbo360.co/page-configuration"))}})})},configureResponse=function(e,n,t){let r="views";return null!=t&&(r=t.views||"views"),{statusCode:200,setHeader:function(e,n){},json:function(e){n(null,{isBase64Encoded:!1,statusCode:200,headers:{"Content-Type":"application/json"},body:JSON.stringify(e)})},data:function(t){t.req=e,n(null,{isBase64Encoded:!1,statusCode:200,headers:{"Content-Type":"application/json"},body:JSON.stringify(t)})},send:function(r){var s={"Content-Type":"text/plain"};n(null,{isBase64Encoded:!1,statusCode:200,headers:setVertexSession(e,s,t),headers:s,body:r})},redirect:function(r){var s={Location:r};n(null,{isBase64Encoded:!1,statusCode:301,headers:setVertexSession(e,s,t),headers:s,body:r})},render:function(s,o){const i=__dirname.replace("node_modules/vertex360/dist/vertex",""),a=s;var c={},u=null,l=null;checkPageConfig(s,e.headers["Turbo-Vertex-App"]).then(t=>{null==o&&(o={}),null==o.page&&null!=t&&(o.page=t);var c=e.headers["turbo-vertex-client"];if(null!=c&&"widget"==c){return o.pageName=o.pageName||s,void n(null,{isBase64Encoded:!1,statusCode:200,headers:{"Content-Type":"application/json"},body:JSON.stringify(o)})}return l=o||{},readFile(i+"/"+r+"/"+a+".mustache")}).then(e=>{return u=e,readRecursiveDirectories(i+"/"+r+"/partials")}).then(e=>(e.forEach(function(e,n){e.path.indexOf(".mustache")>-1&&(c[e.name]=fs.readFileSync(e.path,"utf8"))}),renderMustache({template:u,data:l,partials:c}))).then(r=>{n(null,{isBase64Encoded:!1,statusCode:200,headers:setVertexSession(e,{"Content-Type":"text/html"},t),body:r})}).catch(e=>{n(null,{isBase64Encoded:!1,statusCode:404,headers:{"Content-Type":"application/json"},body:JSON.stringify({confirmation:"fail",message:e.message})})})}}},clearSession=function(){shouldClearSession=!0},bindMiddleware=function(e,n,t){return new Promise((r,s)=>{if(null==t)return void r({req:e,res:n});if(0==t.length)return void r({req:e,res:n});let o=0;const i=function(){if(o<t.length){(0,t[o])(e,n,()=>{o+=1,i()})}else r({req:e,res:n})};i()})};module.exports=function(e,n,t,r,s,o){var i={};if(null!=e.body)try{i=JSON.parse(e.body)}catch(n){e.body.split("&").forEach(function(e,n){var t=e.split("=");2==t.length&&(i[t[0]]=decode(t[1]))})}var a=e.path,c=e.queryStringParameters||{},u=Object.keys(c);u.length>0&&(a+="?",u.forEach(function(e,n){c[e]&&(a+=e+"="+c[e])}));var l={query:c,body:i,headers:e.headers,vertexSessionChanged:!1,method:e.httpMethod.toUpperCase(),url:a};let d=getCookieName(r);var f={reset:clearSession};l[d]=proxyVertexSession(f,l),null!=t&&(l.params=t.params);var h=e.headers.Cookie;if(null!=h){var p=cookie.parse(h);if(null!=p[d])try{const e=sessions.util.decode({cookieName:d,secret:"abc"},p[d]);if(null==e){const e=configureResponse(l,n,r);return void bindMiddleware(l,e,s).then(e=>o(null,{req:e.req,res:e.res})).catch(e=>{reject(e)})}if(null==e.content){const e=configureResponse(l,n,r);return void bindMiddleware(l,e,s).then(e=>o(null,{req:e.req,res:e.res})).catch(e=>{reject(e)})}(f=JSON.parse(e.content)).reset=clearSession,l[d]=proxyVertexSession(f,l);const t=configureResponse(l,n,r);bindMiddleware(l,t,s).then(e=>o(null,{req:e.req,res:e.res})).catch(e=>{reject(e)})}catch(e){l[d]=p[d];const t=configureResponse(l,n,r);bindMiddleware(l,t,s).then(e=>o(null,{req:e.req,res:e.res})).catch(e=>{reject(e)})}else{const e=configureResponse(l,n,r);bindMiddleware(l,e,s).then(e=>o(null,{req:e.req,res:e.res})).catch(e=>{reject(e)})}}else{const e=configureResponse(l,n,r);bindMiddleware(l,e,s).then(e=>o(null,{req:e.req,res:e.res})).catch(e=>{reject(e)})}};